--Enemy Types/Classses
blobPrototype = {}
function newBlob(pHealth, pLevel)
  local blobInstance = {}
  setmetatable(blobInstance, {__index = blobPrototype})
  blobInstance:reset(pHealth, pLevel)
  return blobInstance
end
function blobPrototype:reset(pHealth, pLevel)
  self.HP = pHealth or self.HP or 1
  self.level = pLevel or self.level or 1
  self.age = 0
end
function blobPrototype:update(dt)
  self.age = self.age + (dt or 0)
end
function blobPrototype:draw()
  print("There is a ".. self.age .. "-year(s)-old level" .. self.level .. " blob with " .. self.HP .. " HP")
end

--Usage Example
blob1 = newBlob(3, 2)
blob2 = newBlob()
blob1:update(1)
blob2:update(1)
blob1:draw()
blob2:draw()