--Enemy Types/Classses
blobPrototype = {}
function blobPrototype:new(pHealth, pLevel)
  local blobInstance = {}
  setmetatable(blobInstance, {__index = self})
  blobInstance:reset(pHealth, pLevel)
  return blobInstance
end
function blobPrototype:reset(pHealth, pLevel)
  self.HP = pHealth or self.HP or 1
  self.level = pLevel or self.level or 1
  self.age = 0
end
function blobPrototype:update(dt)
  self.age = self.age + (dt or 0)
end
function blobPrototype:draw()
  print("There is a ".. self.age .. "-year(s)-old level" .. self.level .. " blob with " .. self.HP .. " HP")
end

--Usage Example
enemy = {}
enemy[1] = blobPrototype:new(3, 2)
enemy[2] = enemy[1]:new()           --inherit the values of enemy[1]

--update
for i, ithEnemy in ipairs(enemy) do
  ithEnemy:update(1)
end

--draw
for i, ithEnemy in ipairs(enemy) do
  ithEnemy:draw()
end
